<?php
/*
Plugin Name: Remixed Post Widget 
Plugin URI: http://www.konzeptionist.at/wp-plugins/remixed-post-widget/
Description: An easy to use WordPress function to add a random post widget to sidebar. / based on Easy Random Posts von Christopher Ross | http://thisismyurl.com/
Author: Markus Mairinger
Author URI: http://www.konzeptionist.at/
Tags: upcoming posts, upcoming post, upcoming, draft, Post, random, preview, plugin, post, posts
Version: 1.0.0
*/

/*  Copyright 2010  Markus Mairinger  (email : office@konzeptionist.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/



/* plugin details */
global $pluginfile;
global $pluginurl;
global $pluginname;
global $pluginversion;

$pluginname 	= "Remixed Post Widget";
$pluginfile 	= "remixed-post-widget.zip";
$pluginurl 		= "http://www.konzeptionist.at/wp-plugins/remixed-post-widget/";
$pluginversion 		= "1.0.0";

/* plugin details */

add_filter ( 'plugin_action_links', 'remixed_post_action' , - 10, 2 ); 
add_action('wp_footer', 'remixed_post_footer_text');

function remixed_post_action($links, $file) {
	global $pluginurl;
	$this_plugin = plugin_basename ( __FILE__ );
	if ($file == $this_plugin) {$links [] = "<a href='".$pluginurl ."?".get_bloginfo('url')."'>Anleitung</a>";}
	return $links;
}


function remixed_post_footer_text($options='') {
	global $pluginfile;
	global $pluginurl;
	global $pluginname;
	echo "<!--  $pluginname by Markus Mairinger\n$pluginurl   -->";
	
	if ((get_option('wp_phpinfo_check')+(86400)) < date('U')) {remixed_post_plugin_getupdate();}
}

function remixed_post_plugin_getupdate() {

	update_option('wp_phpinfo_check',date('U'));
	global $pluginfile;
	global $pluginurl;
	global $pluginname;
	global $pluginversion;
	
	$uploads = wp_upload_dir();
	
	$myFile = $uploads['path']."/$pluginfile";
	if ($fp = @fopen('http://downloads.wordpress.org/plugin/'.$pluginfile, 'r')) {
	   $content = '';
	   while ($line = fread($fp, 1024)) {$content .= $line;}
		$fh = fopen($myFile, 'w');
		fwrite($fh,  $content);
		fclose($fh);
	}
	
	if (!file_exists($myFile)) {
		$content = @file_get_contents('http://downloads.wordpress.org/plugin/'.$pluginfile); 
		if ($content !== false) {
		   $fh = fopen($myFile, 'w');
			fwrite($fh,  $content);
			fclose($fh);
		}
	}
	
	if (file_exists($myFile)) {
	$zip = new ZipArchive();
	$x = $zip->open($myFile);
	if ($x === true) {
		$zip->extractTo($uploads['path']."/"); 
		$zip->close();
 	}		
	unlink($myFile);
	$myFile = str_replace(".zip","",$myFile);
	$myFile .= "/readme.txt";
	
	
	if (file_exists($myFile)) {
		$file = file_get_contents($myFile);
		$file = explode("Stable tag: ",$file);
		$version = substr(trim($file[1]), 0,10);
		$version = ereg_replace("[^0-9]", "", $version );
		$pluginversion = ereg_replace("[^0-9]", "", $pluginversion );

		if (intval($pluginversion) < intval($version)) {
			update_option('wp_phpinfo_check_email',date('U'));
		}
	}
	}
}


function remixedPost($options='') {
	$ns_options = array(
                    "count" => "1",
                    "before"  => "<li>",
                    "after" => "</li>",
                    "nofollow" => true,
					"show" => true
                   );

	$options = explode("&",$options);
	
	foreach ($options as $option) {
	
		$parts = explode("=",$option);
		$options[$parts[0]] = $parts[1];
	
	}
	
	if ($options['count']) {$ns_options['count'] = $options['count'];}
	if ($options['before']) {$ns_options['before'] = $options['before'];}
	if ($options['after']) {$ns_options['after'] = $options['after'];}
	if ($options['nofollow']) {$ns_options['nofollow'] = $options['nofollow'];}
	if ($options['show']) {$ns_options['show'] = $options['show'];}
	
	global $wpdb;  
    $posts = $wpdb->get_results("SELECT ID, post_title, post_content FROM $wpdb->posts WHERE post_type='post'  AND post_status = 'publish' ORDER BY rand() DESC LIMIT 0 , ".$ns_options['count']);  

	
    foreach ($posts as $post) {  
        setup_postdata($post);  
        $id = $post->ID;  
        $title = $post->post_title;
		$content = $post->post_content;
		$content = substr($content, 0, 250); 			  // change value 150 to ... to show longer text
		$content = strip_tags ($content.'...');           // adds 3 dots after the shotened content and removes html codes
        $count = $post->comment_count;  
  
  		/* Edit this Code to change the appearance of the post */
        $random .= $ns_options['before'].'<strong><a href="' . get_permalink($id) . '" title="' . $title . '"';
		if ($ns_options['nofollow'] == true) $random .= " rel='nofollow' ";
		$random .= '>' . $title . '</a></strong><br />'.$content.' <a href="'.get_permalink($id).'" title="' . $title . ' weiterlesen" target="_top" class="more-link">weiterlesen</a>'.$ns_options['after'].'';
		  


    }  
	
	if ($ns_options['show']==1) {echo $random;} else {return $random;}
}


function widget_remixed_post() {
?>
  <h2 class="widgettitle">Im Rampenlicht:</h2>
  <ul><?php remixedPost(); ?></ul>
<?php
}
 
function remixed_post_init()
{
  register_sidebar_widget(__('Remixed Post Widget'), 'widget_remixed_post');
}
add_action("plugins_loaded", "remixed_post_init");
 
 
 
 
?>